// addSwetsLinks.js - SwetsWise linker's module
// author: Aart Verweij

var patt = /\b[0-9]{4}[- ]{1}[0-9X]{4}\b/ig;
var swetswiseURL = "https://www.swetswise.com/shop/basicSearchResults.do?mode=view&inputSearchDTO.criteria=3&inputSearchDTO.inputString=";

//walk once now and also put a listener for dynamically changing pages
walk(document.body, addSwetsWiseLinks);
document.body.addEventListener("DOMNodeInserted", function(e) {
  walk(e.target, addSwetsWiseLinks);
}, false);


function isISSN(issnText) {
    var check=[8,7,6,5,4,3,2];
    var total = 0;
    issnText = issnText.replace(/[^0-9X]/gi, '');

    for(var i = 0; i < check.length; i++) {
        var digitCheck = check[i] * issnText.charAt(i).valueOf(); 
        total = total + digitCheck;
    }

    var checkDigit = 11 - total%11;

    if (checkDigit == 11) {
        checkDigit = 0;
    }
    if (checkDigit == 10) {
    	return issnText.charAt(7) == "X";
    }

    return checkDigit == issnText.charAt(7).valueOf()
}

function addSwetsWiseLinks(node){
    if (node.nodeType == 3 && //Text node
		node.parentNode.nodeName != 'A' &&
		node.parentNode.nodeName != 'SCRIPT') { 
		
		var indexOfPattern = node.nodeValue.search(patt);
		if (indexOfPattern > -1) {
			//the regexp matches
        	var match = node.nodeValue.match(patt)[0]; //first match only

            if (isISSN(match)) {
			    //cut the text put in the new A element
    		    node.nodeValue = node.nodeValue.replace(patt, '');
                
                var textAfterLink = node.splitText(indexOfPattern);
			    var link = constructA(match, match.replace(/ /g, ''));
			        
    		    node.parentNode.insertBefore(link,textAfterLink);
            }
		}
	}
}

//constructs an HTML anchor element with specified text
function constructA(text, hrefID) {
	var link = document.createElement('a');
	var linkText = document.createTextNode(text);
	link.setAttribute('href', swetswiseURL + hrefID);
	link.setAttribute('class', 'swetswiselink');
	link.setAttribute('title', 'Search SwetsWise Catalog for this ISSN');
    link.setAttribute('target', 'SwetsWiseWindow');
	link.appendChild(linkText);

	return link;
}

function walk(node, func) {
	func(node);
	node = node.firstChild;
	while (node) {
		walk(node, func);
		node = node.nextSibling;
    }
}
